
function [x2_out P2_out] = stepwise_dr_tu(x2_in,P2_in,dx2,dP)

% Input matrix
sin_phi = sin(x2_in(4));
cos_phi = cos(x2_in(4));

dR = [cos_phi -sin_phi 0 0;
      sin_phi  cos_phi 0 0;
      0        0       1 0;
      0        0       0 1];

F = [1 0 0 -sin_phi*dx2(1)-cos_phi*dx2(2);
     0 1 0 cos_phi*dx2(1)-sin_phi*dx2(2);
     0 0 1 0;
     0 0 0 1];

% Update upper layer system
x2_out = x2_in+dR*dx2;

P2_out = F*P2_in*F' + dR*dP*dR';

end